#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#define MAX 50

void generate_formula (char file[], int count, int num) {
    char letras[25] = "abcdefghijklmnopqrstuwxyz";
    char op[4][4] = {"v","&","=>","-"};
    char letra;
    char file2[50];
    int i, j, chosen, num_variables, had_neg, count2;
    FILE *fp, *fp2;
    
    num_variables = 0;
    count2 = 0;
    had_neg = 0;
    fp = fopen(file,"w");
    sprintf(file2,"../Provador_Prolog/%s",file);
    fp2 = fopen(file2,"w");
    fprintf(fp,"(");
    fprintf(fp2,"tf((");
    num_variables = num;
    for(j=0;j<num_variables;j++) {
        chosen = rand()%4;
        if (chosen != 3) {
            if (had_neg != 1) {
                letra = letras[rand()%25];
                fprintf(fp,"%c %s ",letra,op[chosen]);
                fprintf(fp2,"%c %s ",letra,op[chosen]);
                if(chosen == 2) {
                    fprintf(fp,"(");
                    fprintf(fp2,"(");
                    count2++;
                }
            } else {
                fprintf(fp,"%s ",op[chosen]);
                fprintf(fp2,"%s ",op[chosen]);
                if(chosen == 2) {
                    fprintf(fp,"(");
                    fprintf(fp2,"(");
                    count2++;
                }
                had_neg = 0;
            }
        } else {
            if (had_neg != 1) {
                letra = letras[rand()%25];
                fprintf(fp,"%s%c ",op[chosen],letra);
                fprintf(fp2,"%s%c ",op[chosen],letra);
                had_neg = 1;
            } else {
                j--;
            }
        }
    }
    if (chosen != 3) {
        letra = letras[rand()%25];
        fprintf(fp,"%c",letra);
        fprintf(fp2,"%c",letra);
    }
    for(i=0;i<count2;i++) {
        fprintf(fp,")");
        fprintf(fp2,")");
    }
    fprintf(fp,").\n");
    fprintf(fp2,"), [t]).\n");
    fclose(fp);
    fclose(fp2);
}

int main (int argc, char *argv[]) {
    char filename[50];
    int i, filenum, num;
    
    srand(time(NULL));
    if (argc == 3) {
        filenum = atoi(argv[1]);
        num = atoi(argv[2]);
        for (i=0;i<filenum;i++) {
            sprintf(filename,"formulas/formula%d.ksp",i);
            generate_formula(filename, i, num);
        }
    } else {
        printf("Numero errado de entradas.\n");
    }
    return 0;
}
