#include <string.h>
#include <stdlib.h>  /* malloc */
#include "uthash.h"


#define MAX_INT 2147483646

// Polarity of propositional symbols

#define POSITIVEP    60
#define NEGATIVEP    61

// Classification of clauses

#define POSITIVEC     1
#define NEGATIVEC    -1
#define MIXEDC        0

// Ordering

#define HIGH  1
#define LOW   0

typedef struct prop_node {
  char *name;
  int id;
  int occur;
  UT_hash_handle hh;
  UT_hash_handle hid;
} prop_node;


